﻿<?php defined('_JEXEC') or die('Restricted access');

class pm_cash24 extends PaymentRoot{
	
    function showPaymentForm($params, $pmconfigs){
	   
        include(dirname(__FILE__)."/paymentform.php");
    }

	//function call in admin
	function showAdminFormParams($params){
		

		$array_params = array('online_payment', 'payment_server', 'mnt_id', 'mnt_dataintegrity_code', 'mnt_test_mode', 'mnt_currency_code', 'unitId', 'accountId', 'payanyway_login', 'payanyway_pasword');
		foreach ($array_params as $key){
			if (!isset($params[$key])) $params[$key] = '';
		} 
		$orders = JModelLegacy::getInstance('orders', 'JshoppingModel'); //admin model
		$currencies = JModelLegacy::getInstance('currencies', 'JshoppingModel'); //admin model
		include(dirname(__FILE__)."/adminparamsform.php");	  
	}

   

	function checkTransaction($pmconfigs, $order, $act){
		
		
		$request=$_POST;
$order_id=$request['order'];
if($request['status']=='20'){
	     return array(1, $order_id);
	}
	
	if($request['status']=='40'){
	     return array(1, $order_id);
	}

	}
	
	
	function showEndForm($pmconfigs, $order){
$pm_method = JTable::getInstance('paymentMethod', 'jshop');
        $payment_method_id = $order->payment_method_id;
        $pm_method->load($payment_method_id);
		$jshopConfig = &JSFactory::getConfig();
		
 $time = time() + $pmconfigs['exp'] * 24 * 60 * 60;
  $exptime=gmdate('Y-m-d', $time) . 'T' . gmdate('H:i:s', $time);


$arParams = array();
$arParams['amount']=number_format($order->order_total, 2, '.', '');;
$arParams['currency']='RUB';
$arParams['email']=$order->email;
$arParams['description']='Order '.$order->order_number;
$arParams['order']=$order->order_id;
$arParams['success']=htmlspecialchars(JURI::root() . "index.php?option=com_jshopping&controller=checkout&task=step7&act=return&js_paymentclass=".$pm_method->payment_class);
$arParams['cancel']=htmlspecialchars(JURI::root() . "index.php?option=com_jshopping&controller=checkout&task=step7&act=cancel&js_paymentclass=".$pm_method->payment_class);
$arParams['callback']=htmlspecialchars(JURI::root() . "index.php?option=com_jshopping&controller=checkout&task=step7&act=notify&js_paymentclass=".$pm_method->payment_class);
$arParams['method']=$pmconfigs['payment_server'];
$arParams['phone']=$order->phone;
$arParams['wallet']='';
$arParams['expires']=$exptime;

	

$headers = array(
    "Content-type: text/xml"
    
);
$k= $this->createInvoice($arParams,$pmconfigs['mnt_id'],$pmconfigs['command_key']);

switch ($pmconfigs['mnt_test_mode']) {
				case '1':
					$respurl="http://api.staging.cash24.ru/1.0/";
					break;
				case '0':
					$respurl="https://api.cash24.ru/1.0/";
					break;
			}

   $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $respurl);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER,true);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $k);
 curl_setopt($curl, CURLOPT_HTTPHEADER, $headers );
  
 curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
    $out = curl_exec($curl);
$url = simplexml_load_string($out);

$turl= $url;
 
  $url = $url->response->url; //формируем строку url

  if(!empty($turl->envelope->error)){
  
  
die($turl->envelope->text);
  
  }
   
?>

        <html>
        <body>
        <head>
            <meta http-equiv="content-type" content="text/html; charset=utf-8" />            
        </head>
        <form id="paymentform" action="<?php print $url?>" name = "paymentform" method = "GET">
			
        </form>        
        <?php print _JSHOP_REDIRECT_TO_PAYMENT_PAGE ?>
        <br>
        <script type="text/javascript">document.getElementById('paymentform').submit();</script>
        </body>
        </html>
        <?php
        die();
	}
	
    function getUrlParams($pmconfigs){                        
        $params = array(); 
        $params['order_id'] = JRequest::getInt("order");
        $params['hash'] = "";
        $params['checkHash'] = 0;
        $params['checkReturnParams'] = $pmconfigs['checkdatareturn'];
		
		return $params;
    }
    private function createInvoice($arParams,$auth,$key)
 {
  
  $request = '';
  $toSign = 'create-invoice';
  foreach ($arParams as $c => $val)
  {
   $request .= "<$c>" . $val . "</$c>\r\n";
   if ($c != 'expires' AND $c != 'phone')
    $toSign .= '-' . $val;
  }

  $sign = md5(htmlspecialchars_decode($toSign) . '-' . $key);

  $xml = '
   <?xml version="1.0" encoding="utf-8"?>
   <cash24 xmlns="http://api.cash24.ru/1.0/">
     <request xmlns="http://api.cash24.ru/1.0/create-invoice/">
    ' . $request . '
     </request>
     <envelope>
    <auth>' . $auth . '</auth>
    <sign>' . $sign . '</sign>
     </envelope>
   </cash24>
  ';

  return trim($xml);
 }
}
?>